package aspects.dataManagement.dataCollections.array;

import util.IRepositorioIterable;

import complaint.Complaint;
import complaint.IComplaintRepository;
import exceptions.ObjectNotFoundException;

public class ComplaintRepositoryArray implements IComplaintRepository, IRepositorioIterable {

    private static int nextCode = 1;
    
    private Complaint[] vector;
    private int index;
    private int iteratorIndex;

    public ComplaintRepositoryArray() {
        vector  = new Complaint[5000];
        index = 0;
    }

    public int insert(Complaint complaint)  {
        
        if (complaint == null) {
            throw new IllegalArgumentException();
        }
        
        complaint.setCode(nextCode++);
                
        this.vector[index] = complaint;
        index++;
        
        return vector[index - 1].getCode();
    }

    public void update(Complaint complaint) throws ObjectNotFoundException {
        int i = getIndex(complaint.getCode());
        if (i == index) {
            throw new ObjectNotFoundException("Complaint not found");
        } else {
            vector[i] = complaint;
        }
    }

    public Complaint search(int code) throws ObjectNotFoundException {
        Complaint response = null;
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Complaint not found");
        } else {
            response = vector[i];
        }
        return response;               
    }


    public boolean exists(int code) {
        int i = getIndex(code);
        return (i != index);
    }
        
    public void remove(int code) throws ObjectNotFoundException {
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Complaint not found");
        } else {
            vector[i] = vector[index-1];
            index = index - 1;
        }    
    }
    
    private int getIndex(int code) {
        int temp;
        boolean flag = false;
        int i = 0;
        while ( (!flag) && (i < index) ) {
            temp = vector[i].getCode();
            if (temp == code) {
                flag = true;
            } else {
                i = i + 1;
            }
        }
        return i;
    }    

    // iterator methods
    public void reset() {
        this.iteratorIndex = 0;
    }
    
    public Object next() {
        if (iteratorIndex >= index) {
            return null;
        } else {
            return vector[iteratorIndex++];
        }
    }

    public boolean hasNext() {
        return iteratorIndex < index;
    }
    
}