package aspects.dataManagement.dataCollections.array;

import util.ConcreteIterator;
import util.IRepositorioIterable;
import util.IteratorHW;

import complaint.DiseaseType;
import complaint.IDiseaseRepository;
import exceptions.ObjectNotFoundException;

public class DiseaseRepositoryArray implements IDiseaseRepository, IRepositorioIterable {

    private DiseaseType[] vector;
    private int index;
    private int iteratorIndex;

    public DiseaseRepositoryArray() {
        vector  = new DiseaseType[5000];
        index = 0;
    }
    
    public void insert(DiseaseType disease)  {
        
        if (disease == null) {
            throw new IllegalArgumentException();
        }
        
        this.vector[index] = disease;
        index++;
    }

    public void update(DiseaseType disease) throws ObjectNotFoundException {
        int i = getIndex(disease.getCode());
        if (i == index) {
            throw new ObjectNotFoundException("Disease not found");
        } else {
            vector[i] = disease;
        }
    }

    public DiseaseType search(int code) throws ObjectNotFoundException {
        DiseaseType response = null;
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Disease not found");
        } else {
            response = vector[i];
        }
        return response;               
    }


    public boolean exists(int code) {
        int i = getIndex(code);
        return (i != index);
    }
        
    public void remove(int code) throws ObjectNotFoundException {
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Disease not found");
        } else {
            vector[i] = vector[index-1];
            index = index - 1;
        }    
    }
    
    private int getIndex(int code) {
        int temp;
        boolean flag = false;
        int i = 0;
        while ( (!flag) && (i < index) ) {
            temp = vector[i].getCode();
            if (temp == code) {
                flag = true;
            } else {
                i = i + 1;
            }
        }
        return i;
    }    

 
    public IteratorHW getDiseaseTypeList() {
        return new ConcreteIterator(this);
    }
          
    // iterator methods
    public void reset() {
        this.iteratorIndex = 0;
    }
    
    public Object next() {
        if (iteratorIndex >= index) {
            return null;
        } else {
            return vector[iteratorIndex++];
        }
    }

    public boolean hasNext() {
        return iteratorIndex < index;
    }
    
}