package aspects.dataManagement.dataCollections.array;

import util.IRepositorioIterable;

import complaint.ISymptomRepository;
import complaint.Symptom;
import exceptions.ObjectNotFoundException;

public class SymptomRepositoryArray implements ISymptomRepository, IRepositorioIterable {

    private Symptom[] vector;
    private int index;
    private int iteratorIndex;

    public SymptomRepositoryArray() {
        vector  = new Symptom[5000];
        index = 0;
    }

    		
    public void insert(Symptom symptom)  {
        
        if (symptom == null) {
            throw new IllegalArgumentException();
        }
        
        this.vector[index] = symptom;
        index++;
    }

    public void update(Symptom symptom) throws ObjectNotFoundException {
        int i = getIndex(symptom.getCode());
        if (i == index) {
            throw new ObjectNotFoundException("Symptom not found");
        } else {
            vector[i] = symptom;
        }
    }

    public Symptom search(int code) throws ObjectNotFoundException {
        Symptom response = null;
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Symptom not found");
        } else {
            response = vector[i];
        }
        return response;               
    }


    public boolean exists(int code) {
        int indexAux = 0;
        boolean flag = false;

        for (int i = 0; i < index; i++) {
            if (this.vector[i].getCode() == code) {
                indexAux = i;
                flag    = true;
                break;
            }
        }
        return flag;
    }
        
    public void remove(int code) throws ObjectNotFoundException {
        int i = getIndex(code);
        if (i == index) {
            throw new ObjectNotFoundException("Symptom not found");
        } else {
            vector[i] = vector[index-1];
            index = index - 1;
        }    
    }
    
    private int getIndex(int code) {
        int temp;
        boolean flag = false;
        int i = 0;
        while ( (!flag) && (i < index) ) {
            temp = vector[i].getCode();
            if (temp == code) {
                flag = true;
            } else {
                i = i + 1;
            }
        }
        return i;
    }    

    // iterator methods
    public void reset() {
        this.iteratorIndex = 0;
    }
    
    public Object next() {
        if (iteratorIndex >= index) {
            return null;
        } else {
            return vector[iteratorIndex++];
        }
    }

    public boolean hasNext() {
        return iteratorIndex < index;
    }
    
}