package gui.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Constants;
import util.HTMLCode;
import util.IteratorHW;

import complaint.DiseaseType;

import controllers.HealthWatcherFacade;
import exceptions.ObjectNotFoundException;

public class ServletGetDataForSearchByDiseaseType extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 
            throw new ServletException(e.getMessage());
        }
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;

        response.setContentType("text/html");

        out = response.getWriter();

        
        out.println(HTMLCode.open("Queries - Disease information"));
        out.println("<body><h1>Queries:<br>Querie about diseases</h1>");
        out.println("<p>Choose a disease: </p>");
        out.println("<form method=\"POST\" action=\"http://"+Constants.SERVLET_SERVER_PATH+"/servlet/gui.servlets.ServletSearchDiseaseData\">");

        try {
            out.println("<div align=\"center\"><center><p><select name=\"codTipoDoenca\" size=\"1\">");

            IteratorHW repTP = healthWatcher.getDiseaseTypeList();

            if (!repTP.hasNext()) {
                out.println("</select></p></center></div>");
                out.println("<p><font color=\"red\"><b> There isn't diseases registered.</b></font></p>");
            } else {
                DiseaseType tp;
                do {
                    tp = (DiseaseType) repTP.next();

                    out.println("<option value=\""      +
                                tp.getCode() + "\"> " + 
                                tp.getNome()            +
                                " </OPTION>");
                } while (repTP.hasNext());
                repTP.close();
                
                out.println("</select></p></center></div>");
                out.println("  <div align=\"center\"><center><p><input type=\"submit\" value=\"Search\" name=\"B1\"></p></center></div></form>");
            }
            out.println(HTMLCode.closeQueries());            
        } catch (ObjectNotFoundException e) {
            out.println(HTMLCode.errorPageQueries("There isn't registered diseases"));
        } finally {
            out.close();
        }
    }
}