package gui.servlets;

import healthGuide.HealthUnit;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Constants;
import util.HTMLCode;
import util.IteratorHW;
import controllers.HealthWatcherFacade;
import exceptions.ObjectNotFoundException;

public class ServletGetDataForSearchByHealthUnit extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;

        response.setContentType("text/html");

        out = response.getWriter();

        out.println(HTMLCode.open("Queries - Specialties"));
        out.println("<body><h1>Queries:<br>Search Specialties of a Health unit</h1>");
        out.println("<p>Choose a health unit: </p>");
        out.println("<form method=\"POST\"action=\"http://"+Constants.SERVLET_SERVER_PATH+"/servlet/gui.servlets.ServletSearchSpecialtiesByHealthUnit\">");

        try {
            out.println("  <div align=\"center\"><center><p><select name=\"codUnidadeSaude\" size=\"1\">");

            IteratorHW repUS = healthWatcher.getHealthUnitList();

            if (!repUS.hasNext()) {
                out.println("</select></p></center></div>");
                out.println("<P> There isn't registered health units.</P>");
            } else {
                HealthUnit us;

                do {
                    us = (HealthUnit) repUS.next();

                    out.println("<option value=\""
                                + us.getCode() + "\"> " + us.getDescription()
                                + " </OPTION>");
                } while (repUS.hasNext());

                repUS.close();
                out.println("</select></p></center></div>");
                out.println("  <div align=\"center\"><center><p><input type=\"submit\" value=\"Search\" name=\"B1\"></p></center></div></form>");
            }
            out.println(HTMLCode.closeQueries());
        } catch (ObjectNotFoundException e) {
            out.println("</select></p></center></div>");
            out.println(HTMLCode.errorPageQueries(e.getMessage()));
            out.println("<P> Nenhuma unidade de saude foi cadastrada</P>");
        } finally {
            out.close();
        }
    }
}