package gui.servlets;

import healthGuide.MedicalSpecialty;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.Constants;
import util.HTMLCode;
import util.IteratorHW;
import controllers.HealthWatcherFacade;
import exceptions.ObjectNotFoundException;

public class ServletGetDataForSearchBySpecialty extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;

        response.setContentType("text/html");

        out = response.getWriter();

        out.println(HTMLCode.open("Queries - Health Units"));
        out.println("<body><h1>Queries:<br>Search Health units by Medical specialty</h1>");
        out.println("<p>Choose a specialty: </p>");
        out.println("<form method=\"POST\"action=\"http://"+Constants.SERVLET_SERVER_PATH+"/servlet/gui.servlets.ServletSearchHealthUnitsBySpecialty\">");

        try {
            out.println("<div align=\"center\"><center><p><select name=\"codEspecialidade\" size=\"1\">");
                
            IteratorHW repEsp = healthWatcher.getSpecialtyList();
                      
            if (!repEsp.hasNext()) {
                out.println("</select></p></center></div>");
                out.println("<P>There isn't registered specialties.</P>");
            } else {
                MedicalSpecialty esp;

                do {
                    esp = (MedicalSpecialty) repEsp.next();
                    out.println("<option value=\""
                                + esp.getCode() + "\"> "
                                + esp.getDescription() + " </OPTION>");
                } while (repEsp.hasNext());

                repEsp.close();
                out.println("</select></p></center></div>");
                out.println("  <div align=\"center\"><center><p><input type=\"submit\" value=\"Search\" name=\"B1\"></p></center></div></form>");
            }
            out.println(HTMLCode.closeQueries());
        } catch (ObjectNotFoundException e) {
            out.println("</select></p></center></div>");
            out.println(HTMLCode.errorPageQueries(e.getMessage()));
            out.println("<P>There isn't registered specialties.</P>");
        } finally {
            out.close();
        }
    }
}