package gui.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.HTMLCode;
import controllers.HealthWatcherFacade;
import employee.Employee;
import exceptions.InvalidSessionException;
import exceptions.ObjectAlreadyInsertedException;

public class ServletInsertEmployee extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;
        Employee employee;
        HttpSession session = request.getSession(false);
       
        response.setContentType("text/html");

        out = response.getWriter();

        try {
            if (session == null) {
                throw new InvalidSessionException();
            }            

            //Complaint Normal
            String name = request.getParameter("name");
            String login = request.getParameter("login");
            String password = request.getParameter("password");
            
            employee = new Employee(login, password, name);
            
            this.healthWatcher.insert(employee);

            out.println(HTMLCode.htmlPageAdministrator("Operation executed", "Employee inserted"));

        } catch (ObjectAlreadyInsertedException e) {
            out.println(HTMLCode.errorPageAdministrator("Login already in use, choose another"));
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } finally {
            out.close();
        }
    }
}