package gui.servlets;

import healthGuide.MedicalSpecialty;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import util.HTMLCode;
import util.IteratorHW;
import controllers.HealthWatcherFacade;
import exceptions.ObjectNotFoundException;

public class ServletSearchSpecialtiesByHealthUnit extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }

    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;

        response.setContentType("text/html");

        out = response.getWriter();

        int codigoUS = Integer.parseInt(request.getParameter("codUnidadeSaude"));

        try {

            IteratorHW repEsp = healthWatcher.searchSpecialtiesByHealthUnit(codigoUS);

            out.println(HTMLCode.open("Queries - Especialties"));
            out.println("<body><h1>Querie result</h1>");
            
            out.println("<P><h3>Health unit: " + codigoUS
                        + " </h3></P>");
            out.println("<h3>Especialties :</h3>");

            while (repEsp.hasNext()) {
                MedicalSpecialty esp = (MedicalSpecialty) repEsp.next();
                out.println("<dd><dd>" + esp.getDescription());
            }
            out.println(HTMLCode.closeQueries());
        } catch (ObjectNotFoundException e) {
            out.println(HTMLCode.errorPageQueries("This health unit does not have registered specialties."));
        } finally {
            out.close();
        }
    }
}