package gui.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Calendar;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.Date;
import util.HTMLCode;

import complaint.Complaint;

import controllers.HealthWatcherFacade;
import employee.Employee;
import exceptions.InvalidDateException;
import exceptions.InvalidSessionException;


public class ServletUpdateComplaintData extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {

        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;
        
        HttpSession session = request.getSession(false);
        
        String obsQueixa = request.getParameter("obsQueixa");
        Complaint complaint = null;

        response.setContentType("text/html");

        out = response.getWriter();

        try {
            if (session == null) {
                throw new InvalidSessionException();
            }
            
            complaint = (Complaint) session.getValue(ServletUpdateComplaintSearch.COMPLAINT);
            complaint.setObservation(obsQueixa);
            complaint.setStatus(Complaint.COMPLAINT_CLOSED);
            Calendar agora = Calendar.getInstance();
            complaint.setMedicalOpinionDate(new Date(agora.get(Calendar.DAY_OF_MONTH),
                                                     agora.get(Calendar.MONTH)+1,
                                                     agora.get(Calendar.YEAR)));
            Employee employee = (Employee) session.getValue(ServletLogin.EMPLOYEE);
            complaint.setAttendant(employee);


            out.println(HTMLCode.htmlPageAdministrator("Operation executed", "Complaint updated"+
                                                                             "<P>" + obsQueixa + "</P>"));
            
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } catch (InvalidDateException e) {
            out.println(HTMLCode.errorPageAdministrator(e.getMessage()));
        } finally {
            out.close();
        }
    }

}
