package gui.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.Constants;
import util.HTMLCode;

import complaint.AnimalComplaint;
import complaint.Complaint;
import complaint.FoodComplaint;
/* Cdigo de queixa diversa
import complaint.SpecialComplaint;
*/
import controllers.HealthWatcherFacade;
import exceptions.InvalidSessionException;
import exceptions.ObjectNotFoundException;
import exceptions.StatusClosedException;


public class ServletUpdateComplaintSearch extends HttpServlet {

    private HealthWatcherFacade healthWatcher;
    public static final String COMPLAINT = "complaint";

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            throw new ServletException(e.getMessage());
        }
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;
        HttpSession session = request.getSession(false);
        
        response.setContentType("text/html");

        out = response.getWriter();
      
        try {
            if (session == null) {
                throw new InvalidSessionException();
            }            

            int complaintCode = 0;
                        
            complaintCode = (new Integer(request.getParameter("numQueixa"))).intValue();
            Complaint complaint = healthWatcher.searchComplaint(complaintCode);
           
            session.putValue(ServletUpdateComplaintSearch.COMPLAINT, complaint);
            
            if (complaint.getStatus() != Complaint.COMPLAINT_OPENED) {
                throw new StatusClosedException("Complaint not open");
            }
    
            out.println(HTMLCode.open("Update complaint"));
            out.println("<script language=\"javascript\">");
            out.println("function submeterDados(modulo)");
            out.println("{");
    
            String a1 = "\"";
            String a2 = "\"";
    
            out.println("   var f = document.formAlterarQueixa2;");
            out.println("   if(f.obsQueixa.value ==" + a1 + a2 + ")");
            out.println("   {");
            out.println("           alert(\"Digite o parecer da queixa!\");");
            out.println("           f.obsQueixa.select();");
            out.println("           return;");
            out.println("   }");
            out.println("   f.submit();");
            out.println("}");
            out.println("//--></script>");
            out.println("<body><h1>Update Complaint:</h1>");
    
            out.println("<form method=\"POST\" name=\"formAlterarQueixa2\" action=\"http://"+Constants.SERVLET_SERVER_PATH+"/servlet/gui.servlets.ServletUpdateComplaintData\">");
            out.println("<div align=\"center\"><center><h4>Complaint : "
                        + complaintCode
                        + "</h4></center></div>");

            if (complaint instanceof FoodComplaint) {
                out.println("<div align=\"center\"><center><p><strong>Complaint kind: Food complaint</strong></p></center></div>");
            } else if (complaint instanceof AnimalComplaint) {
                out.println("<div align=\"center\"><center><p><strong>Complaint kind: Animal complaint</strong></p></center></div>");
/* Cdigo de queixa diversa                
            } else if (complaint instanceof SpecialComplaint) {
            	out.println("<div align=\"center\"><center><p><strong>Complaint kind: Special complaint</strong></p></center></div>");
*/            	
            }

            out.println("<div align=\"center\"><center><p><strong>Description: "
                        + complaint.getDescription() + "</strong></p></center></div>");
            out.println("<div align=\"center\"><center><p><strong>Observation (complaint's solution):</strong><br><textarea rows=\"5\" name=\"obsQueixa\" cols=\"22\"></textarea></p></center></div>");
            out.println("<div align=\"center\"><center><h4><input type=\"button\" value=\"Update\" name=\"bt1\" onClick=\"javascript:submeterDados();\"><input type=\"reset\" value=\"Clear\" name=\"bt2\"></h4></center></div></form>");
            out.println(HTMLCode.closeAdministrator());            
        } catch (ObjectNotFoundException e) {
            out.println(HTMLCode.errorPageAdministrator("Complaint does not exist!"));
        } catch (StatusClosedException e) {
            out.println(HTMLCode.errorPageAdministrator("This complaint's status is closed!"));
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } finally {
            out.close();
        }
    }
}
