package gui.servlets;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.HTMLCode;
import controllers.HealthWatcherFacade;
import employee.Employee;
import exceptions.InvalidSessionException;

public class ServletUpdateEmployeeData extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {

        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;
        HttpSession session = request.getSession(false);
        
        String name = request.getParameter("name");
        String password = request.getParameter("password");
        String newPassword = request.getParameter("newPassword");
        Employee employee = null;

        response.setContentType("text/html");

        out = response.getWriter();

        try {
            if (session == null) {
                throw new InvalidSessionException();
            }
            
            employee = (Employee) session.getValue(ServletLogin.EMPLOYEE);
            
            if (employee.validatePassword(password)) {
                employee.setName(name);
                if (!newPassword.equals("")) {
                    employee.setPassword(newPassword);
                }
                
                out.println(HTMLCode.htmlPageAdministrator("Operation executed", "Employee updated"));
            } else {
                out.println(HTMLCode.errorPageAdministrator("Invalid password!"));
            }
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } finally {
            out.close();
        }
    }
}
