package gui.servlets;

import healthGuide.HealthUnit;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.HTMLCode;
import controllers.HealthWatcherFacade;
import exceptions.InvalidSessionException;

public class ServletUpdateHealthUnitData extends HttpServlet {

    private HealthWatcherFacade healthWatcher;

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response)
                throws ServletException, IOException {

        PrintWriter out;        
        HttpSession session = request.getSession(false);
        
        response.setContentType("text/html");

        out = response.getWriter();

        HealthUnit unit;

        try {           
            if (session == null) {
                throw new InvalidSessionException();
            }
            
            unit = (HealthUnit) session.getValue(ServletUpdateHealthUnitSearch.HEALTH_UNIT);                        
            
            String descricao = request.getParameter("descricao");            
            
            unit.setDescription(descricao);                       
            
            out.println(HTMLCode.htmlPageAdministrator("Operation executed", "Health Unit updated"));
            
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } finally {
            out.close();
        }
    }

}
