package gui.servlets;

import healthGuide.HealthUnit;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import util.Constants;
import util.HTMLCode;
import controllers.HealthWatcherFacade;
import exceptions.InvalidSessionException;
import exceptions.ObjectNotFoundException;

public class ServletUpdateHealthUnitSearch extends HttpServlet {

    private HealthWatcherFacade healthWatcher;
    public static final String HEALTH_UNIT = "health unit";

    public void init(ServletConfig config) throws ServletException {
        try {
            healthWatcher = HealthWatcherFacade.getInstance();
        } catch (Exception e) {
            System.out.println(e.getMessage()); 

            throw new ServletException(e.getMessage());
        }
    }
    
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

        PrintWriter out;        
        HttpSession session = request.getSession(false);
        
        response.setContentType("text/html");

        out = response.getWriter();
        
        try {        
            if (session == null) {
                throw new InvalidSessionException();
            }        
        
            out.println(HTMLCode.open("Update Health Unit"));
            out.println("<script language=\"javascript\">");
            out.println("function submeterDados(modulo)");
            out.println("{");
    
            String a1 = "\"";
            String a2 = "\"";
    
            out.println("   var f = document.formAlterarUnidade2;");
            out.println("   if(f.descricao.value ==" + a1 + a2 + ")");
            out.println("   {");
            out.println("           alert(\"Type the new Health Unit description!\");");
            out.println("           f.descricao.select();");
            out.println("           return;");
            out.println("   }");
            out.println("   f.submit();");
            out.println("}");
            out.println("//--></script>");
            out.println("<body><h1>Update Health unit:</h1>");
    
            int numUS = (new Integer(request.getParameter("numUS"))).intValue();
            
            HealthUnit unit = healthWatcher.searchHealthUnit(numUS);

            session.putValue(ServletUpdateHealthUnitSearch.HEALTH_UNIT, unit);

            
            out.println("<form method=\"POST\" name=\"formAlterarUnidade2\" action=\"http://"+Constants.SERVLET_SERVER_PATH+"/servlet/gui.servlets.ServletUpdateHealthUnitData\">");
            out.println("<div align=\"center\"><center><h4>Unit: " + numUS + "</h4></center></div>");                      
            out.println("<div align=\"center\"><center><p><strong>Name:</strong><br><input type=\"text\" name=\"descricao\" value=\"" + unit.getDescription() + "\" size=\"60\"></p></center></div>");
            out.println("<div align=\"center\"><center><h4><input type=\"button\" value=\"Update\" name=\"bt1\" onClick=\"javascript:submeterDados();\"><input type=\"reset\" value=\"Clear\" name=\"bt2\"></h4></center></div></form>");            
            out.println(HTMLCode.closeAdministrator());            
            
        } catch (ObjectNotFoundException e) {
            out.println(HTMLCode.errorPageAdministrator("Health unit does not exist!"));
        } catch (InvalidSessionException e) {
            out.println(HTMLCode.getIvalidSessionYouMustLoginAgain());
        } finally {
            out.close();
        }
    }

}
