package util;

public class ConcreteIterator implements LocalIterator {

    private IRepositorioIterable rep = null;

    public ConcreteIterator(IRepositorioIterable rep) {
        this.rep = rep;
        if (rep != null) {
            this.rep.reset();
        }
    }

    public boolean hasNext() {
        if (rep != null) {
            return rep.hasNext();
        } else {
            return false;
        }
    }

    public Object next() {
        if (rep != null) {
            return rep.next();
        } else {
            return null;
        }
    }

    public void remove() {}

    public void close() {}
}